var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "event-mailer-config.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);


function checkAndUpdateData()
{
	// migrate v1 to trigger data structure
	var fMigrate=false;
	var basePropertyArray = Property.getNode('values');
	if (basePropertyArray!=null) {
		var subPropArray = basePropertyArray.getChildren();
		for ( var iIndex = 0; iIndex < subPropArray.length; iIndex++) {
			var baseProp = subPropArray[iIndex];

			if (baseProp.getChild('disabled')!=null) {
			    fMigrate=true;
                var fDisabled=baseProp.getChild('disabled').getValue();
                lInfo.logln("fDisabled: " + fDisabled);
                
                if (fDisabled) {
                    Property.setProperty(baseProp.getPath() + '/conditions/enabled', false);
                    Property.setFlag(baseProp.getPath()+'/conditions/enabled','ARCHIVE',true);
                } else {
                    Property.setProperty(baseProp.getPath() + '/conditions/enabled', true);
                    Property.setFlag(baseProp.getPath()+'/conditions/enabled','ARCHIVE',true);
                }
                baseProp.removeChild('disabled');
			}
	            
			var triggerProp = baseProp.getChild('trigger');
			if (triggerProp!=null) {
				var triggerZone = triggerProp.getChild('zone');				
				var triggerGroup = triggerProp.getChild('group');
				var triggerScene = triggerProp.getChild('scene');
				if (triggerZone != null)
					if (triggerGroup != null)
						if (triggerScene != null) {

						    var triggerZoneID=triggerZone.getValue();
                            var triggerGroupID=triggerGroup.getValue();
                            var triggerSceneID=triggerScene.getValue();
                            lInfo.logln("Triggering on : " + triggerZoneID + " " + triggerGroupID + " " + triggerSceneID);

                            if (triggerZoneID == 0) {
                                lInfo.logln("Trigger-zone is 0 -> setting to -1");
                                triggerZoneID = -1;
                            }
                            
                            if ((triggerSceneID == 65) || ((triggerSceneID >= 71) && (triggerSceneID <= 73))) {
                                triggerGroupID = 0;
                                triggerZoneID = 0;
                                lInfo.logln("Trigger-scene is Panik, Kommen, Gehen or Klingel -> force setting group and zone to 0");
                            } else if (triggerSceneID >= 64) {
                                triggerGroupID = 0;
                                lInfo.logln("Trigger-scene is apartment scene -> force setting group to 0");
                            }
                            
							fMigrate=true;						
							Property.setProperty(baseProp.getPath()+'/triggers/1/type','zone-scene');
							Property.setProperty(baseProp.getPath()+'/triggers/1/scene',triggerSceneID);
							Property.setProperty(baseProp.getPath()+'/triggers/1/group',triggerGroupID);
                            Property.setProperty(baseProp.getPath()+'/triggers/1/zone',triggerZoneID);
                            Property.setProperty(baseProp.getPath()+'/triggers/1/dsid',-1);
                            
							Property.setFlag(baseProp.getPath()+'/triggers/1/zone','ARCHIVE',true);
							Property.setFlag(baseProp.getPath()+'/triggers/1/group','ARCHIVE',true);
							Property.setFlag(baseProp.getPath()+'/triggers/1/scene','ARCHIVE',true);
                            Property.setFlag(baseProp.getPath()+'/triggers/1/type','ARCHIVE',true);
                            Property.setFlag(baseProp.getPath()+'/triggers/1/dsid','ARCHIVE',true);
							baseProp.removeChild('trigger');
						}
			}
			var messageProp = baseProp.getChild('message');
			if (messageProp!=null) {
				var messageBody = messageProp.getChild('message');
				if (messageBody!=null)
				{
					fMigrate=true;
					Property.setProperty(messageProp.getPath()+'/messageBody',messageBody.getValue());
					Property.setFlag(messageProp.getPath()+'/messageBody','ARCHIVE',true);
					messageProp.removeChild('message');
				}
			}

		}
	}
	// patch the "evt" - node to "eventid" if possible
	lInfo.logln('Checke nach evt-nodes');
	basePropertyArray = Property.getNode('values');
    if (basePropertyArray!=null) {
        lInfo.logln('1');
        var subPropArray = basePropertyArray.getChildren();
        for ( var iIndex = 0; iIndex < subPropArray.length; iIndex++) {
            lInfo.logln('values found ' + iIndex);
            if (subPropArray[iIndex].getChild('triggers')!=null) {
                var triggerArray = subPropArray[iIndex].getChild('triggers').getChildren();
                if (triggerArray!=null) {
                    lInfo.logln('trigger found ' + iIndex);
                    for ( var jIndex = 0; jIndex < triggerArray.length; jIndex++) {
                        if (triggerArray[jIndex].getChild('type')!=null)
                            if (triggerArray[jIndex].getChild('type').getValue()=="device-sensor") {
                                lInfo.logln('trigger sensor found ' + iIndex);
                                if (triggerArray[jIndex].getChild('evt')!=null) {
                                    var sEVT=triggerArray[jIndex].getChild('evt').getValue();
                                    var sDSID=triggerArray[jIndex].getChild('dsid').getValue();
                                    lInfo.logln('device ' + sDSID + ' ' + sEVT);
                                    var oEventArray=Property.getNode('/apartment/zones/zone0/devices/' + sDSID + '/sensorEvents').getChildren();
                                    if (oEventArray!=null) {
                                        for (var kIndex=0;kIndex<oEventArray.length;kIndex++) {
                                            if (oEventArray[kIndex].getValue()==sEVT) {
                                                lInfo.logln('device found : id ' +oEventArray[kIndex].name);
                                                Property.setProperty(triggerArray[jIndex].getPath()+'/eventid',oEventArray[kIndex].name);
                                                Property.setFlag(triggerArray[jIndex].getPath()+'/eventid','ARCHIVE',true);
                                                triggerArray[jIndex].removeChild('evt');
                                                fMigrate=true;
                                            }
                                        }
                                    }                                    
                                }
                            }
                    }            
                }
            }
        }
    }
	
	
	if (fMigrate)
		Property.store();
}